首页 > web前端 > js教程 > LeetCode 冥想:断词

LeetCode 冥想:断词

Linda Hamilton
发布: 2024-12-19 22:36:14
原创
953 人浏览过

LeetCode Meditations: Word Break

此问题的描述是:

给定一个字符串 s 和一个字符串字典 wordDict,如果 s 可以分割成一个或多个字典单词的空格分隔序列,则返回 true。

注意词典中的同一个单词在分词中可能会重复使用多次。

例如:

Input: s = "leetcode", wordDict = ["leet", "code"]
Output: true

Explanation: Return true because "leetcode" can be segmented as "leet code".
登录后复制
登录后复制

或者:

Input: s = "applepenapple", wordDict = ["apple", "pen"]
Output: true

Explanation: Return true because "applepenapple" can be segmented as "apple pen apple".
Note that you are allowed to reuse a dictionary word.
登录后复制
登录后复制

或者:

Input: s = "catsandog", wordDict = ["cats", "dog", "sand", "and", "cat"]
Output: false
登录后复制
登录后复制

此外,我们的约束表明wordDict 的所有字符串都是**唯一**,并且:

  • 1
  • 1
  • 1
  • s 和 wordDict[i] 仅由小写英文字母组成。

继续动态编程解决方案,我们可以看看一种流行的自下而上的方法,我们构建一个 dp 数组来跟踪是否可以在每个索引处将 s 分解为 wordDict 中的单词。

每个索引 dp 数组中将指示是否可以将整个字符串分解为从索引开始的单词 .

Note
dp needs to be of size s.length 1 to hold the edge case of an empty string, in other words, when we're out of bounds.

让我们用最初的错误值来创建它:

Input: s = "leetcode", wordDict = ["leet", "code"]
Output: true

Explanation: Return true because "leetcode" can be segmented as "leet code".
登录后复制
登录后复制

最后一个索引是空字符串,可以认为它是可破坏的,或者换句话说,有效的:

Input: s = "applepenapple", wordDict = ["apple", "pen"]
Output: true

Explanation: Return true because "applepenapple" can be segmented as "apple pen apple".
Note that you are allowed to reuse a dictionary word.
登录后复制
登录后复制

向后看,对于 s 的每个索引,我们可以检查从该索引开始是否可以到达 wordDict 中的任何单词:

Input: s = "catsandog", wordDict = ["cats", "dog", "sand", "and", "cat"]
Output: false
登录后复制
登录后复制

如果我们仍在 s 的范围内 (i word.length

let dp = Array.from({ length: s.length + 1 }, () => false); // +1 for the base case, out of bounds
登录后复制

如果我们可以将其分解为wordDict中的任何单词,我们就不必继续查看其他单词,因此我们可以跳出循环:

dp[s.length] = true; // base case
登录后复制

最后,我们返回 dp[0] - 如果整个字符串可以分解为 wordDict 中的单词,则其值将存储 true,否则为 false:

for (let i = s.length - 1; i >= 0; i--) {
  for (const word of wordDict) {
    /* ... */
  }
}
登录后复制

而且,这是最终的解决方案:

for (let i = s.length - 1; i >= 0; i--) {
  for (const word of wordDict) {
    if (i + word.length <= s.length && s.slice(i, i + word.length) === word) {
      dp[i] = dp[i + word.length];
    }
    /* ... */
  }
}
登录后复制

时间和空间复杂度

时间复杂度为 O(n*m*tO(n * m * t) O(n*m*t) 在哪里 nn n 是字符串 s, 是 wordDict 中的单词数,并且 tt t 是 wordDict 中的最大长度单词 - 因为我们有一个嵌套循环,通过切片操作遍历 wordDict 中的每个单词,该切片操作使用 s 中每个字符的 word.length。

空间复杂度为 O(n)O(n) O(n) 因为我们为 s 的每个索引存储 dp 数组。


该系列中的最后一个动态规划问题将是最长递增子序列。在那之前,祝您编码愉快。

以上是LeetCode 冥想:断词的详细内容。更多信息请关注PHP中文网其他相关文章!

来源:dev.to
本站声明
本文内容由网友自发贡献,版权归原作者所有,本站不承担相应法律责任。如您发现有涉嫌抄袭侵权的内容,请联系admin@php.cn
作者最新文章
热门教程
更多>
最新下载
更多>
网站特效
网站源码
网站素材
前端模板